﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;

namespace Infragistics.Test
{
  public partial class MainForm : Form
  {
    private readonly OverflowIndicatorFilter _filter = new OverflowIndicatorFilter();

    public MainForm()
    {
      InitializeComponent();
      var viewer = new Win.UIElementViewer.UIElementViewerControl {Dock = DockStyle.Fill};
      tableLayoutPanel1.Controls.Add(viewer, 0, 0);

      FormatGrid();
    }

    private void OnLoad(object sender, EventArgs e)
    {
      _properties.SelectedObject = _grid;

      _grid.DataSource = new List<TestData>
                                {
                                  new TestData
                                    {
                                      String = "hello dave",
                                      Date = new DateTime(1981, 10, 16),
                                      Double = 1234.5678,
                                    },
                                  new TestData
                                    {
                                      String = "hello computer",
                                      Date = DateTime.Today,
                                      Double = 8765.4321,
                                    },
                                  new TestData
                                    {
                                      String = "hello yellow",
                                      Date = DateTime.Today.AddDays(2),
                                      Double = 12.34,
                                    }
                                };
    }

    private void FormatGrid()
    {
      _grid.DisplayLayout.GroupByBox.Hidden = true;
      _grid.DisplayLayout.Override.CellDisplayStyle = Win.UltraWinGrid.CellDisplayStyle.FormattedText;
      _grid.DisplayLayout.Override.CellClickAction = Win.UltraWinGrid.CellClickAction.CellSelect;
      _grid.DisplayLayout.Override.ActiveRowAppearance.BackColor = System.Drawing.Color.Empty;
      _grid.DisplayLayout.Override.ActiveRowAppearance.ForeColor = System.Drawing.SystemColors.ControlText;
      _grid.DisplayLayout.Override.CellAppearance.TextTrimming = Win.TextTrimming.None;
      _grid.DrawFilter = _filter;
      _grid.DisplayLayout.Override.CellAppearance.BorderColor = System.Drawing.Color.Black;
      _grid.DisplayLayout.Override.BorderStyleCell = Win.UIElementBorderStyle.Solid;
      _grid.DisplayLayout.Override.BorderStyleRow = Win.UIElementBorderStyle.Solid;
      _grid.DisplayLayout.Override.RowAppearance.BorderColor = System.Drawing.Color.Black;
    }

    private class TestData
    {
      public string String { get; set; }
      public DateTime Date { get; set; }
      public double Double { get; set; }
    }

    private void OnClick(object sender, EventArgs e)
    {
      FormatGrid();
    }
  }
}
